#!/usr/bin/perl 
 
# ****************************************************************** 
# This file generates the make.inc file for each platform 
# ****************************************************************** 
 
$USAGE = "Usage: build.pl <platform> <target>\n"; 
 
if ($#ARGV < 1) { 
    print "Give me some more arguments stupid\n"; 
    print $USAGE; 
    exit (1) 
} 
 
open (outFile, ">./make.inc") ||  
    die "Sorry, I can't create make.inc\n"; 
 
# Set global variables 
 
if ($ARGV[0] eq "buckeye") { 
    $ARCH    ="BUCKEYE";
    $ARCHDIR ="buckeye";
} 
elsif ($ARGV[0] eq "fir") { 
    $ARCH    ="FIR";
    $ARCHDIR ="fir";
} 
elsif ($ARGV[0] eq "madrona") { 
    $ARCH    ="MADRONA";
    $ARCHDIR ="madrona";
} 
elsif ($ARGV[0] eq "redwood") { 
    $ARCH    ="REDWOOD";
    $ARCHDIR ="redwood";
} 
elsif ($ARGV[0] eq "nitshade") { 
    $ARCH    ="NITSHADE";
    $ARCHDIR ="nitshade";
} 
elsif ($ARGV[0] eq "sitka") { 
    $ARCH    ="SITKA";
    $ARCHDIR ="sitka";
} 
elsif ($ARGV[0] eq "bear") { 
    $ARCH    ="BEAR";
    $ARCHDIR ="bear";
} 
elsif ($ARGV[0] eq "polar") { 
    $ARCH    ="POLAR";
    $ARCHDIR ="polar";
} 
elsif ($ARGV[0] eq "l440gx") { 
    $ARCH    ="L440GX";
    $ARCHDIR ="l440gx";
} 
elsif ($ARGV[0] eq "h820") { 
    $ARCH    ="H820";
    $ARCHDIR ="h820";
}
elsif ($ARGV[0] eq "k840") { 
    $ARCH    ="K840";
    $ARCHDIR ="k840";
}
else { 
    print "You actualy think I know how to build the platform: $ARGV[0]\n"; 
    print $USAGE; 
    exit(1); 
} 
 
if ($ARGV[1] eq "dbg") { 
    $OUTDIR  ="./dbg"; 
    $CDBGOPT = "-g"; 
    $RELTYPE = "-DUWDEBUG -D_DEBUG"; 
} 
elsif ($ARGV[1] eq "rel") { 
    $OUTDIR  ="./rel"; 
    $CDBGOPT = ""; 
    $RELTYPE = ""; 
} 
else { 
    print "I don't get it.... target is: $ARGV[1]\n"; 
    print $UASGE; 
} 
 
$CC      = "cc"; 
$AR      = "AR"; 
 
$COPTS   = "-DUNIX -DFLAT32 -W0,-B -K PIC -D\$(ARCH) -DREENTRANT -DUWSVR4 -Kthread \$(RELTYPE) \$(CDBGOPT)"; 
$CCOPTS  = "-c -DUNIX -DFLAT32 -K PIC -D_KERNEL -D\$(ARCH) -DREENTRANT -DUWSVR4 -Kthread \$(RELTYPE) \$(CDBGOPT)"; 
 
# Print out the main.inc file 
print outFile <<EOF; 

\#************************************************************ 
\# main.inc                                                  * 
\# This file has been generated by the build.pl script       * 
\#************************************************************ 
 
CDBGOPT = $CDBGOPT 
RELTYPE = $RELTYPE 
OUTDIR  =$OUTDIR
  
pvmaj = 1         \# major version number 
pvmin = 2         \# minor version number 
pvrev = 0         \# revision number e.g. A,B,C,.. 
 
ARCH=$ARCH
ARCHDIR=$ARCHDIR
 
OS      = UNIXWARE 
 
CFLAGS  = /d\$(ARCH) /d\$(OS) 
 
\# Options for c compile 
COPTS   = $COPTS 
 
\# Options for c++ compile 
CCOPTS = $CCOPTS 
 
EOF
