/*----------------------------------------------------------
* File Contents:
*     imb_asyn.h
* Project: IMB Driver
*-----------------------------------------------------------
* Copyright (c) 2002-2006 Intel Corporation 
*---------------------------------------------------------*/
/*M*                     
 *  This program is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by the
 *  Free Software Foundation; either version 2 of the License, or (at your
 *  option) any later version.
 *
 *  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
 *  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 *  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 *  OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 *  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 *  TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 *  USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.  
*M*/
/*---------------------------------------------------------*/
/*
 * $Log: imb_asyn.h $
 * Revision 1.1  2002/12/11 06:45:48Z  mks
 * Initial revision
 */

#ifndef IMB_ASYN_H__
#define IMB_ASYN_H__
//
// Async message queue structures
//
typedef DWORD	OsInfo;	// place holder for compiling, until really defined (in OS modules)

#define MAX_SMS_MESSAGE_SIZE	34
#define IMB_ASYNC_QUEUE_SIZE	10

typedef struct {
	BYTE	length;
	BYTE	data[ MAX_SMS_MESSAGE_SIZE ];
} ImbAsyncEntry;
//
// This structure holds state information about the queue
//
typedef struct {
	ImbAsyncSeq		startSeqNo;		// sequence number of oldest entry
	DWORD			startOffset;	// entry in the queue which the oldest valid entry
	DWORD			count;			// valid number of entries
	DWORD			queueSize;		// in entries
	ImbAsyncEntry *	queue;			// pointer to queue data
	ImbAsyncOsSem	syncSem;		// synchronization variable for the queue
	ImbAsyncOsEvent	waitEvent;		// synchronization variable for those waiting for msgs
} ImbAsyncQueueInfo;

#endif // IMB_ASYN_H__
