/*----------------------------------------------------------
* File Contents:
*     kcs.h 
* Project: IMB Driver
*-----------------------------------------------------------
* Copyright (c) 2002-2006 Intel Corporation 
*---------------------------------------------------------*/
/*M*                     
 *  This program is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by the
 *  Free Software Foundation; either version 2 of the License, or (at your
 *  option) any later version.
 *
 *  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
 *  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 *  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 *  OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 *  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 *  TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 *  USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.  
*M*/
/*---------------------------------------------------------*/
/*
 * $Log: kcs.h $
 * Revision 1.1  2002/12/11 06:49:10Z  mks
 * Initial revision
 */

#define KCS_READY_DELAY		WAIT_5_MS
#define BMC_RESPONSE_DELAY	WAIT_5_MS	// how long to wait for a response after sending req
#define BMC_RETRY_DELAY		(60 * WAIT_1_MS)	// how long to wait after an error before retrying
//
// Keyboard Controller Style Interface addresses and defines
//
#if defined(__ia64__)
#define KCS_BASE		0x8a2
#else
#define KCS_BASE		0xca2
#endif
#define KCS_COMMAND_REGISTER	(KCS_BASE + 1)
#define KCS_STATUS_REGISTER	(KCS_BASE + 1)
#define KCS_DATAIN_REGISTER	KCS_BASE
#define KCS_DATAOUT_REGISTER	KCS_BASE

#define MAX_INVALID_RESPONSE_COUNT	2	// number of BMC request send retries 

//
// Status register bit flags
//
#define KCS_STATE_MASK		0xc0
#define KCS_IDLE_STATE		0x00
#define KCS_READ_STATE		0x40
#define KCS_WRITE_STATE		0x80
#define KCS_ERROR_STATE		0xc0

#define KCS_IBF			0x02
#define KCS_OBF			0x01

#define KCS_SMS_ATN		0x04

//
// State machine states
//
#define TRANSFER_INIT		1
#define TRANSFER_START		2
#define TRANSFER_NEXT		3
#define TRANSFER_END		4	// send last byte of request
#define RECEIVE_START		5	// wait for BMC to transition to read state
#define RECEIVE_INIT		6	// wait for first data byte to become available
#define RECEIVE_NEXT		7	// collect data byte and ask for more
#define RECEIVE_INIT2		8	// wait for next data byte to become available
#define RECEIVE_END		9
#define MACHINE_END		10
#define TRANSFER_ERROR		0

//
// KCS commands
//
#define WRITE_START		0x61
#define WRITE_END		0x62
#define READ_DATA		0x68


