/*----------------------------------------------------------
* File:    smic.h 
* Project: IMB Driver
*-----------------------------------------------------------
* Copyright (c) 2002-2006 Intel Corporation 
*---------------------------------------------------------*/
/*M*                     
 *  This program is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by the
 *  Free Software Foundation; either version 2 of the License, or (at your
 *  option) any later version.
 *
 *  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
 *  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 *  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 *  OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 *  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 *  TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 *  USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.  
*M*/
/*---------------------------------------------------------*/
/*
 * $Log: smic.h $
 * Revision 1.1  2002/12/11 07:26:52Z  mks
 * Initial revision
 * 
*/
// SMIC hardware register addresses
//
#define SMIC_DATA_REGISTER 0x0CA9       /* SMIC Data Reg. address */
#define SMIC_CNTL_REGISTER 0x0CAA       /* SMIC Control Reg. address */
#define SMIC_FLAG_REGISTER 0x0CAB       /* SMIC Flags Reg. address */

//
// flag register defines
//
#define SMIC_BUSY		0x01
#define SMS_AVAIL		0x04
#define SMM_AVAIL		0x08
#define SMI_AVAIL		0x10
#define TX_DATA_RDY		0x40
#define RX_DATA_RDY		0x80

//
// Defines for delay and timeout values
//
#define SMIC_READY_DELAY	WAIT_5_MS	// how long to wait for SMIC if to come ready
#define BMC_RESPONSE_DELAY	WAIT_10_MS	// how long to wait for a response after sending req
#define BMC_RETRY_DELAY		(60 * WAIT_1_MS)	// how long to wait after an error before retrying

#define MAX_INVALID_RESPONSE_COUNT	2	// number of BMC request send retries 

//
//	SMIC tranfer/receive operation state machine states
//

#define TRANSFER_INIT   0
#define TRANSFER_START  1
#define TRANSFER_NEXT   2
#define TRANSFER_END    3
#define TRANSFER_ABORT  4
#define RECEIVE_INIT    5
#define RECEIVE_START   6
#define RECEIVE_NEXT    7
#define RECEIVE_END     8
#define RECEIVE_ABORT   9
#define MACHINE_END     128

//
// Server Management Software(SMS) Transfer Stream Control Code definition
//
#define SMS_CC_GET_STATUS		0x40
#define SMS_CC_START_TRANSFER		0x41
#define SMS_CC_NEXT_TRANSFER		0x42
#define SMS_CC_END_TRANSFER		0x43
#define SMS_CC_START_RECEIVE            0x44
#define SMS_CC_NEXT_RECEIVE             0x45
#define SMS_CC_END_RECEIVE		0x46
#define SMS_CC_TRANSFER_ABORT		0x47

//
// Server Management Software(SMS) Transfer Stream Status Code definition
//
#define SMS_SC_READY			0x0c0
#define SMS_SC_WRITE_START		0x0c1
#define SMS_SC_WRITE_NEXT		0x0c2
#define SMS_SC_WRITE_END		0x0c3
#define SMS_SC_READ_START		0x0c4
#define SMS_SC_READ_NEXT		0x0c5
#define SMS_SC_READ_END			0x0c6

