Summary: Intel IMB IPMI driver 
Name: imbsrc
Version: 5.6.0
Release: 29
License: GPL
Vendor: Intel Corporation
Group: Driver

%description
The Intel IMB IPMI driver provides access to the IPMI BMC firmware.
This rpm builds the imb driver module from source.

%prep

%build

%install
SOURCEDIR=/usr/dev/imb
DRVDIR=/usr/local
mkdir -p $DRVDIR/imbsrc
cd $SOURCEDIR
find . -print |cpio -pdumv $DRVDIR/imbsrc
install -m 755 -o 0 -g 0 $SOURCEDIR/install/common/imbload /etc/init.d

%undefine __check_files

%files
/usr/local/imbsrc/*
%dir /usr/local/imbsrc/
/etc/init.d/imbload

%clean
SMIDRV_INSTALLED=`rpm -qa | grep "\<imbsrc\>" | cut -d "-" -f1`
if [ "imbsrc" = "$SMIDRV_INSTALLED" ]; then
  echo "An imb driver RPM package is currently installed. Will not remove /usr/local/imbsrc"
else
  rm -rf $DRVDIR/imbsrc
  rm -f /etc/init.d/imbload 2> /dev/NULL
fi

%post
ARCH=`uname -i`
KERNELVERSION=`uname -r | sed "s/-/./" | cut -d "." -f1-2`
MODDIR=/lib/modules/`uname -r`/kernel/drivers/char
cd /usr/local/imbsrc

export IMBSRC=`pwd`
cd imb
make clean
make
if [ "2.4" = "$KERNELVERSION" ]; then
	install -m755 -o0 -g0 ./imb.o $MODDIR/imb.o
else
# if [ "2.6" = "$KERNELVERSION" ]; then
	install -m755 -o0 -g0 ./imb.ko $MODDIR/imb.ko
fi

which chkconfig  2>/dev/null
if [ $? -eq 0 ]; then
   chkconfig --add imbload
fi
/etc/init.d/imbload start

%preun
/etc/init.d/imbload stop

%postun
rm -rf /usr/local/imbsrc
rm -f /etc/init.d/imbload 2> /dev/NULL

