#ifndef _I2CP_DEFS_
#define _I2CP_DEFS_

#include "hardware.h"

#define I2C_BUSA			0
#define I2C_BUSB			1
#define I2CA_BASE_ADDRESS	0xca0

#define NUM_I2C_RESOURCES   1
#define NUM_I2C_PORTS       2

// used to convert timer duration into Microseconds.

#define MSEC_TO_TIMER	10	


// used to indicate that there is a pending read
#define IRP_TAKEN        (PIRP)1

typedef struct _I2C_DEVICE_EXTENSION {

//
// We keep the following values around so that we can connect
// to the interrupt and report resources after the configuration
// record is gone.
//

	PDEVICE_OBJECT	DeviceObject;
	ULONG			I2CBus;
	ULONG			PhysicalAddress;
	PUCHAR			Port;
	ULONG			PortAccessDelay;
	ULONG			NodeNumber;
	KSPIN_LOCK		I2CDriverLock;
	PKSPIN_LOCK		DriverLock;
	LARGE_INTEGER	PollTime;
	KTIMER			PollTimer;
	KDPC			PollTimerDpc;
	ULONG			RetryCount;

	BOOLEAN			DeviceOpened;
	BOOLEAN			WantResponseData;
	BOOLEAN			BlockRead;
	PIRP			CurrentReadIrp;
	ULONG			ResponseSize;
	RING_BUFFER		ResponseData;

	struct _I2C_DEVICE_EXTENSION	*FirstDeviceExtension;
	struct _I2C_DEVICE_EXTENSION	*NextDeviceExtension;

} I2C_DEVICE_EXTENSION, *PI2C_DEVICE_EXTENSION;






#if DBG
#define I2CDebugPrint(arg) DbgPrint arg
#else
#define I2CDebugPrint(arg)
#endif


#endif // _I2CP_DEFS_

