#ifndef _RINGBUF_DEFS_
#define _RINGBUF_DEFS_

#define MAX_USHORT		65536


typedef struct _RING_BUFFER {
	ULONG			Size;
	PUCHAR			Start;
	PUCHAR			End;
	PUCHAR			Head;
	PUCHAR			Tail;
} RING_BUFFER, *PRING_BUFFER;



NTSTATUS
RingBufAllocate(
	PRING_BUFFER	RingBuffer,
	POOL_TYPE		MemoryType,
	ULONG			Size
    );


NTSTATUS
RingBufFree(
	PRING_BUFFER	RingBuffer
    );

ULONG
RingBufNextDataBlockSize(
	PRING_BUFFER	RingBuffer
	);

NTSTATUS
RingBufAddData(
	PRING_BUFFER	RingBuffer,
	PUCHAR			Data,
	ULONG			DataSize
    );

NTSTATUS
RingBufRetrieveData(
	PRING_BUFFER	RingBuffer,
	PUCHAR			Data,
	PULONG			DataSize
    );

BOOLEAN
RingBufIsEmpty(
	PRING_BUFFER	RingBuffer
    );


#endif // _RINGBUF_DEFS_

