#ifndef _SMBDRV_H
#define _SMBDRV_H

#include "bcl.h"

#if defined(UWSVR4) || defined(UNIX)
#define SMB_TXT_NT		"/dev/instruments/smb0"
#else
#define SMB_TXT_NT            __TEXT("\\\\.\\Smb")
#endif // UWSVR4

#define I2C_TXT_NTNAME      L"\\Device\\I2CA" 			// These are currently defined in i2c.c
#define I2C_TXT_DOS         L"\\DosDevices\\I2CA"		// These are currently defined in i2c.c
#define SMB_TXT_NTNAME	    L"\\Device\\SMB"
#define SMB_TXT_DOS         L"\\DOSDevices\\Smb"

#define SMB_I2C_ADDRESS		0x52


#define SMB_AGENT_READ_TIMEOUT  20
#define AC_LOSS_RIDE_THRU_PERIOD 10

#define SMB_MILSEC_BASE		10000	   					// NT uses a 100ns base timer period

#define SMB_BASE_TIMER_PERIOD	(1000*SMB_MILSEC_BASE)	// 1 sec

#define SMB_MAX_SEND_RETRIES	3


#define DISABLE_WD_OS_DOWN		0xff
#define DISABLE_WD_KDB			0xfe
#define DISABLE_WD_SYSDUMP		0xfd
#define DISABLE_WD_UNLOAD		0xfc

#define MAX_NUMBER_I2C_DEVICE_NODES	24

#pragma pack(1)
typedef struct i2cwritebuf {
LONG I2CAddress;
bcl_serial_t BclPacket;
} I2C_WRITE_BUF, *PI2C_WRITE_BUF;
#pragma pack()

//
// Device Type
//

#define FILE_DEVICE_SMB	0x00008002

//
// I/O Control codes
//

#define IOCTL_SMB_FUNCTION_CODE_BASE			0x0800	// For Custom

#define IOCTL_SMB_SEND_GET_REPLY (ULONG)CTL_CODE(FILE_DEVICE_SMB, IOCTL_SMB_FUNCTION_CODE_BASE + 1, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_SMB_STOP_WATCHDOG (ULONG)CTL_CODE(FILE_DEVICE_SMB, IOCTL_SMB_FUNCTION_CODE_BASE + 2, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_SMB_SET_AGENT_READ_INTERVAL (ULONG)CTL_CODE(FILE_DEVICE_SMB, IOCTL_SMB_FUNCTION_CODE_BASE + 3, METHOD_BUFFERED, FILE_ANY_ACCESS)

#endif // _SMBDRV_H

