#ifndef _SMBLOG_
#define _SMBLOG_

//
//  Status values are 32 bit values layed out as follows:
//
//   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
//   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
//  +---+-+-------------------------+-------------------------------+
//  |Sev|C|       Facility          |               Code            |
//  +---+-+-------------------------+-------------------------------+
//
//  where
//
//      Sev - is the severity code
//
//          00 - Success
//          01 - Informational
//          10 - Warning
//          11 - Error
//
//      C - is the Customer code flag
//
//      Facility - is the facility code
//
//      Code - is the facility's status code
//

// Initial value is
// LanguageNames=(English=1:MSG00001)
// default is, can be 10
// OutputBase = 16
// Now starts the messages
//
//  Values are 32 bit values layed out as follows:
//
//   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
//   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
//  +---+-+-+-----------------------+-------------------------------+
//  |Sev|C|R|     Facility          |               Code            |
//  +---+-+-+-----------------------+-------------------------------+
//
//  where
//
//      Sev - is the severity code
//
//          00 - Success
//          01 - Informational
//          10 - Warning
//          11 - Error
//
//      C - is the Customer code flag
//
//      R - is a reserved bit
//
//      Facility - is the facility code
//
//      Code - is the facility's status code
//
//
// Define the facility codes
//


//
// Define the severity codes
//


//
// MessageId: SMB_ERROR_LOG_CODE_UNABLE_TO_INIT_I2C_DRIVER
//
// MessageText:
//
//  Unable to register with I2C Driver to receive slave mode I2C data.
//
#define SMB_ERROR_LOG_CODE_UNABLE_TO_INIT_I2C_DRIVER ((ULONG)0xC1000001L)

//
// MessageId: SMB_ERROR_LOG_CODE_INSUFFICIENT_RESOURCES
//
// MessageText:
//
//  Insufficient system resources available for driver.
//
#define SMB_ERROR_LOG_CODE_INSUFFICIENT_RESOURCES ((ULONG)0xC1000002L)

//
// MessageId: SMB_ERROR_LOG_CODE_I2C_READ_FAILED
//
// MessageText:
//
//  Read to I2C Driver failed.
//
#define SMB_ERROR_LOG_CODE_I2C_READ_FAILED ((ULONG)0xC1000003L)

//
// MessageId: SMB_ERROR_LOG_CODE_SHUTDOWN_NOTIFICATION_REG_FAILED
//
// MessageText:
//
//  Unable to register for shutdown notification.
//
#define SMB_ERROR_LOG_CODE_SHUTDOWN_NOTIFICATION_REG_FAILED ((ULONG)0xC1000004L)

//
// MessageId: SMB_ERROR_LOG_CODE_UNABLE_TO_OPEN_I2C_DRIVER
//
// MessageText:
//
//  Unable to attach to I2C Driver. Verify that I2C Driver is installed and started
//
#define SMB_ERROR_LOG_CODE_UNABLE_TO_OPEN_I2C_DRIVER ((ULONG)0xC1000005L)

//
// MessageId: SMB_ERROR_LOG_CODE_UNABLE_TO_CREATE_DEVICE
//
// MessageText:
//
//  Unable to create device.
//
#define SMB_ERROR_LOG_CODE_UNABLE_TO_CREATE_DEVICE ((ULONG)0xC1000006L)

//
// MessageId: SMB_ERROR_LOG_CODE_UNABLE_TO_LINK_DEVICE
//
// MessageText:
//
//  Unable to link to device.
//
#define SMB_ERROR_LOG_CODE_UNABLE_TO_LINK_DEVICE ((ULONG)0xC1000007L)

//
// MessageId: SMB_ERROR_LOG_CODE_UNABLE_FREE_READIRP
//
// MessageText:
//
//  Unable to free I2C read Irp because it could not be cancelled.
//
#define SMB_ERROR_LOG_CODE_UNABLE_FREE_READIRP ((ULONG)0x81000008L)

//
// MessageId: SMB_ERROR_LOG_CODE_UNABLE_FREE_ACTIVEREAD
//
// MessageText:
//
//  Unable to free Read Buffer because I2C read Irp could not be cancelled.
//
#define SMB_ERROR_LOG_CODE_UNABLE_FREE_ACTIVEREAD ((ULONG)0x81000009L)

//
// MessageId: SMB_ERROR_LOG_CODE_ALREADY_OPENED
//
// MessageText:
//
//  An application attempted to open the driver when the driver was previously opened.
//  Only one open is allowed to this device.
//
#define SMB_ERROR_LOG_CODE_ALREADY_OPENED ((ULONG)0x8100000AL)

//
// MessageId: SMB_ERROR_LOG_CODE_SET_HEARTBEAT_TO_SMB_FAILED
//
// MessageText:
//
//  Enabling/Disabling of the heartbeat protocol to the SMB failed.
//
#define SMB_ERROR_LOG_CODE_SET_HEARTBEAT_TO_SMB_FAILED ((ULONG)0x8100000BL)

//
// MessageId: SMB_ERROR_LOG_CODE_IRP_TO_I2C_FAILED
//
// MessageText:
//
//  An Irp sent to the I2C Driver completed with bad status.
//
#define SMB_ERROR_LOG_CODE_IRP_TO_I2C_FAILED ((ULONG)0xC100000CL)

//
// MessageId: SMB_ERROR_LOG_CODE_READ_BUFFER_POINTER_CORRUPT
//
// MessageText:
//
//  The buffer pointer in an Irp returned by a read from the I2C Driver has been corrupted.
//
#define SMB_ERROR_LOG_CODE_READ_BUFFER_POINTER_CORRUPT ((ULONG)0xC100000DL)

//
// MessageId: SMB_ERROR_LOG_CODE_BAD_ACK_FROM_SMB
//
// MessageText:
//
//  An acknowledgement has been received from the SMB while no commands are outstanding.
//
#define SMB_ERROR_LOG_CODE_BAD_ACK_FROM_SMB ((ULONG)0x8100000EL)

//
// MessageId: SMB_ERROR_LOG_CODE_BAD_ACK_SEQ_NUMBER_FROM_SMB
//
// MessageText:
//
//  An acknowledgement has been received from the SMB with a bad sequence number.
//
#define SMB_ERROR_LOG_CODE_BAD_ACK_SEQ_NUMBER_FROM_SMB ((ULONG)0x8100000FL)

//
// MessageId: SMB_ERROR_LOG_CODE_DUPLICATE_ACK_FROM_SMB
//
// MessageText:
//
//  An acknowledgement has been received from the SMB for a previously acknowledged command.
//
#define SMB_ERROR_LOG_CODE_DUPLICATE_ACK_FROM_SMB ((ULONG)0x81000010L)

//
// MessageId: SMB_ERROR_LOG_CODE_SMB_EVENT_BUT_NO_AGENT
//
// MessageText:
//
//  An event was received from the SMB, but the agent has not connected to the driver.
//
#define SMB_ERROR_LOG_CODE_SMB_EVENT_BUT_NO_AGENT ((ULONG)0x81000011L)

//
// MessageId: SMB_ERROR_LOG_CODE_SMB_EVENT_NOT_QUEUED_TO_DRIVER
//
// MessageText:
//
//  An event was received from the SMB but there was insufficient resources to queue the event to the agent.
//  The message was discarded.
//
#define SMB_ERROR_LOG_CODE_SMB_EVENT_NOT_QUEUED_TO_DRIVER ((ULONG)0x80FF0001L)

//
// MessageId: SMB_ERROR_LOG_CODE_VALID_UKNOWN_BCL_MESSAGE
//
// MessageText:
//
//  A valid BCL message was received from the SMB that was not an acknowledgment, event, or command reply. 
//  The message was discarded.
//
#define SMB_ERROR_LOG_CODE_VALID_UKNOWN_BCL_MESSAGE ((ULONG)0x81000012L)

//
// MessageId: SMB_ERROR_LOG_CODE_REPLY_WITH_NO_COMMAND_OUTSTANDING
//
// MessageText:
//
//  A command reply was received from the SMB with no outstanding commands.
//
#define SMB_ERROR_LOG_CODE_REPLY_WITH_NO_COMMAND_OUTSTANDING ((ULONG)0x81000013L)

//
// MessageId: SMB_ERROR_LOG_CODE_SMB_OK_EVENT_QUEUED_TO_AGENT
//
// MessageText:
//
//  A previously failed SMB is now responding to heartbeats. 
//  Attempting to send this event to the agent.
//
#define SMB_ERROR_LOG_CODE_SMB_OK_EVENT_QUEUED_TO_AGENT ((ULONG)0x41000014L)

//
// MessageId: SMB_ERROR_LOG_CODE_SMB_TIMEOUT_EVENT_QUEUED_TO_AGENT
//
// MessageText:
//
//  The SMB heartbeat has timed out. 
//  Attempting to send this event to the agent.
//
#define SMB_ERROR_LOG_CODE_SMB_TIMEOUT_EVENT_QUEUED_TO_AGENT ((ULONG)0xC1000015L)

//
// MessageId: SMB_ERROR_LOG_CODE_BAD_REPLY_TO_SMB_HEARTBEAT
//
// MessageText:
//
//  A bad commnad reply was received from a driver initiated SMB heartbeat.
//
#define SMB_ERROR_LOG_CODE_BAD_REPLY_TO_SMB_HEARTBEAT ((ULONG)0x81000016L)

//
// MessageId: SMB_ERROR_LOG_CODE_READ_OR_IOCTL_BEFORE_OPEN
//
// MessageText:
//
//  ReadFile() or DeviceIoControl() called before CreateFile().
//
#define SMB_ERROR_LOG_CODE_READ_OR_IOCTL_BEFORE_OPEN ((ULONG)0x81000017L)

//
// MessageId: SMB_ERROR_LOG_CODE_BAD_IOCTL_CODE
//
// MessageText:
//
//  DeviceIoControl() was called with an unrecognized IOCTL code.
//
#define SMB_ERROR_LOG_CODE_BAD_IOCTL_CODE ((ULONG)0x81000018L)

//
// MessageId: SMB_ERROR_LOG_CODE_BAD_BCL_COMMAND_LENGTH
//
// MessageText:
//
//  DeviceIoControl() was called with a BCL Command that has a bad length.
//
#define SMB_ERROR_LOG_CODE_BAD_BCL_COMMAND_LENGTH ((ULONG)0x81000019L)

//
// MessageId: SMB_ERROR_LOG_CODE_BUFFER_TO_SMALL
//
// MessageText:
//
//  The receive buffer passed to the driver by the agent is too small.
//
#define SMB_ERROR_LOG_CODE_BUFFER_TO_SMALL ((ULONG)0x8100001AL)

//
// MessageId: SMB_ERROR_LOG_CODE_BAD_BCL_BUFFER_LENGTH
//
// MessageText:
//
//  DeviceIoControl() was called with a BCL command length that does not match the buffer length.
//
#define SMB_ERROR_LOG_CODE_BAD_BCL_BUFFER_LENGTH ((ULONG)0x8100001BL)

//
// MessageId: SMB_ERROR_LOG_CODE_READ_WHILE_READ_OUTSTANDING
//
// MessageText:
//
//  ReadFile() was called while a previous ReadFile() is outstanding.
//
#define SMB_ERROR_LOG_CODE_READ_WHILE_READ_OUTSTANDING ((ULONG)0x8100001CL)

//
// MessageId: SMB_ERROR_LOG_CODE_AGENT_TIMEOUT
//
// MessageText:
//
//  The agent has timed out by not providing a ReadFile() call to the Driver within the specified period.
//
#define SMB_ERROR_LOG_CODE_AGENT_TIMEOUT ((ULONG)0xC100001DL)

//
// MessageId: SMB_ERROR_LOG_CODE_SET_SMB_HEARTBEAT_TIMEOUT
//
// MessageText:
//
//  The driver was unable to successfult enable/disable the SMB heartbeat because the SMB timed out.
//
#define SMB_ERROR_LOG_CODE_SET_SMB_HEARTBEAT_TIMEOUT ((ULONG)0xC100001EL)

//
// MessageId: SMB_ERROR_LOG_CODE_WAIT_FOR_IOCANCELIRP_TIMEDOUT
//
// MessageText:
//
//  The Driver was unable to free an Irp on Unload due to a delay in the return of IoCancelIrp().
//
#define SMB_ERROR_LOG_CODE_WAIT_FOR_IOCANCELIRP_TIMEDOUT ((ULONG)0xC100001FL)

//
// MessageId: SMB_ERROR_LOG_CODE_IOCTL_TIMEOUT
//
// MessageText:
//
//  A DeviceIoControl() call has timed out to the SMB.
//
#define SMB_ERROR_LOG_CODE_IOCTL_TIMEOUT ((ULONG)0xC1000020L)

//
// MessageId: SMB_ERROR_LOG_CODE_LOCAL_EVENT_TIMEOUT
//
// MessageText:
//
//  A driver initiated out-of-band event has timed out to the SMB.
//
#define SMB_ERROR_LOG_CODE_LOCAL_EVENT_TIMEOUT ((ULONG)0xC1000021L)

//
// MessageId: SMB_ERROR_LOG_CODE_INTERNAL_DRIVER_ERROR
//
// MessageText:
//
//  The driver has detected an internal error.
//
#define SMB_ERROR_LOG_CODE_INTERNAL_DRIVER_ERROR ((ULONG)0xC1000022L)

//
// MessageId: SMB_ERROR_LOG_CODE_LOCAL_EVENT_DISCARDED
//
// MessageText:
//
//  A driver initiated event was discarded since the driver has not been opened.
//
#define SMB_ERROR_LOG_CODE_LOCAL_EVENT_DISCARDED ((ULONG)0x81000023L)

//
// MessageId: SMB_ERROR_LOG_CODE_SHUTDOWN_FAILED
//
// MessageText:
//
//  An AC power loss was detected, but the driver was unable to request a shutdown from the Agent.
//
#define SMB_ERROR_LOG_CODE_SHUTDOWN_FAILED ((ULONG)0x81000024L)

// These defines are used to build the Unique Error or Event ID
#define SMB_DRIVER_ENTRY                   0
#define SMB_ATTACH_TO_I2C                  100
#define SMB_INITIALIZE_I2C                 200
#define SMB_CREATE_DEVICE                  300
#define SMB_FREE_POOL                      400
#define SMB_INITIALIZE_DEVICE_EXTENSION    500
#define SMB_OPEN                           600
#define SMB_CLEANUP                        700
#define SMB_DO_CLEANUP                     800
#define SMB_UNLOAD                         900
#define SMB_SET_HEARTBEAT_INTERVAL         1000
#define SMB_SHUTDOWN                       1100
#define SMB_SEND_READ_TO_I2C               1200
#define SMB_SEND_DEVICE_CONTROL_TO_I2C		1300
#define SMB_BASIC_IO_COMPLETION            1400
#define SMB_COMPLETE_IRP                   1500
#define SMB_I2C_READ_IO_COMPLETETION		1600
#define SMB_PROCESS_BCL_ACK                1700
#define SMB_PROCESS_BCL_EVENT              1800
#define SMB_PROCESS_BCL_REPLY              1900
#define SMB_DISPATCH                       2000
#define SMB_DEVICE_IO_CONTROL_CANCEL       2100
#define SMB_READ_CANCEL                    2200
#define SMB_BASE_TIMER                     2300
#define SMB_SEND_TIMER                     2400
#define SMB_BUILD_SEND_PACKET_TO_SMB       2500
#define SMB_START_NEXT_SEND                2600
#define SMB_SEND_MESSAGE_TO_SMB            2700
#define SMB_SEND_IO_COMPLETION             2800
#define SMB_SEND_ACKNOWLEDGE               2900
#define SMB_SEND_IN_BAND_EVENT_TO_AGENT    3000
#define SMB_GET_QUEUE_ITEM                 3100
#define SMB_UNQUEUE_QUEUE_ITEM             3200
#define SMB_SEND_ERROR_LOG                 3300
#endif // _SMBLOG_
