
#ifndef _SMBPARAM_H
#define _SMBPARAM_H

/* The Following should be added to the space.c in Unix


#include "sys/smi/smbparam.h" 

SMB_PARAMETERS SmbParameters = {
	SMB_DEFAULT_HEARTBEAT_INTERVAL,
	SMB_DEFAULT_ACK_TIMEOUT_INTERVAL,
	SMB_DEFAULT_REPLY_TIMEOUT_INTERVAL
	};

*/

/*
 Default values - MP-RAS and NT
*/

#define SMB_DEFAULT_HEARTBEAT_INTERVAL 20                             /* 20 secs*/
#define SMB_DEFAULT_ACK_TIMEOUT_INTERVAL (2 * 1000 * 10000)           /* 2 secs*/
#define SMB_DEFAULT_REPLY_TIMEOUT_INTERVAL (10 * 1000 * 10000)        /* 10 secs*/

typedef struct _SMB_PARAMETERS {
LONG HeartbeatInterval;
LONG AckTimeoutInterval;
LONG ReplyTimeoutInterval;
} SMB_PARAMETERS, *PSMB_PARAMETERS;

/*
 Subkey Name containing Values to over ride defaults - NT only
*/

#define SMB_PARAM_SUBKEY L"\\Parameters"

/*
 Value names to over ride defaults - NT only
*/

#define SMB_REG_HEARTBEAT_INTERVAL L"HeartbeatInterval"
#define SMB_REG_ACK_TIMEOUT_INTERVAL L"AckTimeoutInterval"
#define SMB_REG_REPLY_TIMEOUT_INTERVAL L"ReplyTimeoutInterval"

#define SMB_REG_QUERIES 3

#endif /* _SMBPARAM_H*/
