
/******************************************************************************\
*
*                                 SMIDEBUG.H
*
\******************************************************************************/

#ifndef _SMIDEBUG_H
#define _SMIDEBUG_H
#include <stdio.h>
#include <smi/ultrace.h>

typedef enum {
	LOG_DEBUG1=3,
	LOG_DEBUG2,
	LOG_DEBUG3,
	LOG_DEBUG4,
	LOG_DEBUG5
} TraceLogLevels;


typedef enum {

	SMI_NO_DEBUG,
	SMI_ERRORS=LOG_DEBUG3,
	SMI_TRACE_ALL=LOG_DEBUG5

} SMIDebugLevels; 
#ifdef __cplusplus
extern "C" {
#endif // __cplusplus
int testDebugMask ( int, unsigned long );
void  debugAbort ( void );
#ifdef __cplusplus 
}
#endif //__cplusplus

#ifdef  DEV_DEBUG
#ifdef  __cplusplus
extern "C" {
#endif  // __cplusplus
int  getSLInterfaceTransNum ( void );
void printKeyListData ( int, void * );
void releaseToken ( void );
void getToken ( void );
void dev_debug_break_point ( void );
void dev_debug_break2_point ( void );
void dev_debug_break3_point ( void );
void dev_debug_break4_point ( void );
void printKeyList ( int, void * );
void printDmiCiAttribute ( int ,  void * );
void printsisInfo ( int, void  * );
void printDmiReq (int, void  * );
void printSLHandle ( int, void * );
void printDmiCnf ( int, void  * );
int  printDmiMgmtCommand ( int, void  * ); 
void printDmiAccessData ( int, void * );
void printaccessEntry ( int, void * );
void printCiCommand ( int, void * );
void printDmiRegisterMgntReq ( int, void  * );
void printDmiListComponentReq ( int,  void  * );
void printDmiListGroupReq ( int, void  * );
void printDmiListAttributeReq ( int,  void  * );
void printDmiListDescReq ( int,  void  * );
void printDmiGetAtributeReq ( int , void * );
void printDmiGetRowCnf ( int, void * );
void printDmiGetAttributeData ( int, void * );
void printDmiGetAttributeCnf ( int, void * );
void printDmiGroupKeyData ( int, void * );
void printDmiSetAttributeReq ( int, void * );
void printDmiGetRowReq ( int, void * );
// void printDmiSLDmiIndicate (
void printDmCiInstallData ( int, void * );
void printDmiUninstallData ( int, void * );
void printDmiRegisterCiInd ( int, void * );
//  void printDmiUnregisterCiInd (
#ifdef __cplusplus
}
#endif  //__cplusplus
#endif   // DEV_DEBUG  stuff
#define SMI_DEFAULT_LEVEL	SMI_NO_DEBUG

typedef
void
(*PDEBUG_ROUTINE) (
	char *str
	);

/*
 * Sub-System Debug Mask
 */
#define DEBUG_TEMP_SIS_MASK                0x0001   // Temperature Sub-system debug mask
#define DEBUG_FAN_SIS_MASK                 0x0002   // Fan Sub-system debug mask 
#define DEBUG_VOLTAGE_SIS_MASK             0x0004   // Voltage Sub-system debug mask
#define DEBUG_SECURITY_SIS_MASK            0x0008   // Security Sub-system debug mask
#define DEBUG_SECURITY_SENSOR_SIS_MASK     0x0010   // Security sensor Sub-system debug mask
#define DEBUG_STS_DISPLAY_SIS_MASK         0x0020   // Display Sub-system debug mask
#define DEBUG_SYSTEM_CNTRL_SIS_MASK        0x0040   // System Control Sub-system debug mask
#define DEBUG_MEM_ARRAY_SIS_MASK           0x0080   // Memory Sub-system debug mask
#define DEBUG_PWR_SIS_MASK                 0x0100   // Power Sub-system debug mask
#define DEBUG_VDB_MASK                     0x0200   // VDB debug mask

#define DEBUG_MAX_LIMIT_SIS_MASK           0x03FF   // SIS debug Bound check mask 
#define DEBUG_MAX_LIMIT_MASK               0x001F   // Bound check mask
#define DEBUG_LEVEL                            1    // It is a debug mask test
#define DEBUG_SUBSYS                           2    // Itis a sub-system test
 
#define DEBUG_STRUCT_MASK                  0x0001   // Struct enable mask
#define DEBUG_FUNC_MASK                    0x0002   // Function enable mask
#define DEBUG_PERSON_MASK                  0x0004   // Programmer own wish mask
#define DEBUG_VDB_REGISTER                 0x0008   // print list of group being register with sl
#define DEBUG_SIS_INDICATION               0x0010   // log sis indication 
#endif	/* _SMIDEBUG_H */
