
#ifndef	_WINDOWS_H
#define	_WINDOWS_H

#ifndef FALSE
#define FALSE   0
#endif
#ifndef TRUE
#define TRUE    1
#endif
#ifndef NULL
#define NULL 0
#endif

#ifndef _WCHAR_T
#define _WCHAR_T
typedef long    wchar_t;
#endif

#define far
#define near
#define FAR                 far
#define NEAR                near
#ifndef CONST
#define CONST               const
#endif

#if (defined(__x86_64__) || defined(__ia64__))
   /* typedef unsigned int  DWORD;  * DWORD is 4 bytes */
#endif
   typedef unsigned long DWORD;
typedef int                 BOOL;
typedef unsigned char       BYTE;
typedef unsigned short      WORD;
typedef float               FLOAT;
typedef FLOAT               *PFLOAT;
typedef BOOL near           *PBOOL;
typedef BOOL far            *LPBOOL;
typedef BYTE near           *PBYTE;
typedef BYTE far            *LPBYTE;
typedef int near            *PINT;
typedef int far             *LPINT;
typedef WORD near           *PWORD;
typedef WORD far            *LPWORD;
typedef long far            *LPLONG;
typedef DWORD near          *PDWORD;
typedef DWORD far           *LPDWORD;
typedef void far            *LPVOID;
typedef CONST void far      *LPCVOID;

typedef int                 INT;
typedef unsigned int        UINT;
typedef unsigned int        *PUINT;

#define	MAX_PATH	260
/*
  File structures
*/

typedef struct _OVERLAPPED {
    DWORD   Internal;
    DWORD   InternalHigh;
    DWORD   Offset;
    DWORD   OffsetHigh;
/*    HANDLE  hEvent; */
} OVERLAPPED, *LPOVERLAPPED;

/*
 * NT data structure redefines
 */
typedef char CHAR;
typedef short SHORT;
typedef long LONG;
typedef char * PCHAR;
typedef short * PSHORT;
typedef long * PLONG;
typedef unsigned char UCHAR;
typedef unsigned short USHORT;
typedef unsigned long ULONG;
typedef unsigned char * PUCHAR;
typedef unsigned short * PUSHORT;
typedef unsigned long * PULONG;
typedef char CCHAR;
typedef short CSHORT;
typedef ULONG CLONG;
typedef CCHAR * PCCHAR;
typedef CSHORT * PCSHORT;
typedef CLONG * PCLONG;
typedef void VOID;
typedef void * PVOID;
typedef struct _LARGE_INTEGER {
	ULONG LowPart;
	LONG HighPart;
} LARGE_INTEGER;
typedef LARGE_INTEGER * PLARGE_INTEGER;
typedef LARGE_INTEGER PHYSICAL_ADDRESS;
typedef LARGE_INTEGER * PPHYSICAL_ADDRESS;
typedef struct _ULARGE_INTEGER {
	ULONG LowPart;
	ULONG HighPart;
} ULARGE_INTEGER;
typedef ULARGE_INTEGER * PULARGE_INTEGER;

/*
 Boolean
*/

typedef UCHAR BOOLEAN;
typedef BOOLEAN *PBOOLEAN;

typedef wchar_t		    WCHAR;
typedef WCHAR		    *PWCHAR, *PWSTR;
typedef CONST WCHAR	    *LPCWSTR, *PCWSTR;

/*
 Unicode strings are counted 16-bit character strings. If they are
 NULL terminated, Length does not include trailing NULL.
*/

typedef struct _UNICODE_STRING {
    USHORT Length;
    USHORT MaximumLength;
    PWSTR  Buffer;
} UNICODE_STRING;
typedef UNICODE_STRING *PUNICODE_STRING;
#define UNICODE_NULL ((WCHAR)0) /* winnt*/

#define IN	/* */
#define OUT	/* */
#define OPTIONAL	/* */
#define UNREFERENCED_PARAMETER(x)
#define FIELD_OFFSET(type, field)    ((LONG)&(((type *)0)->field))
typedef	int HANDLE;
typedef	HANDLE	*PHANDLE;
#define	INVALID_HANDLE_VALUE	((HANDLE)-1)


/*
 Priority increment definitions.  The comment for each definition gives
 the names of the system services that use the definition when satisfying
 a wait.


 Priority increment when no I/O has been done.  This is used by device
 and file system drivers when completing an IRP (IoCompleteRequest).
*/

#define IO_NO_INCREMENT                 0

/*
 Define the method codes for how buffers are passed for I/O and FS controls
*/

#define METHOD_BUFFERED                 0
#define METHOD_IN_DIRECT                1
#define METHOD_OUT_DIRECT               2
#define METHOD_NEITHER                  3

/*
 Define the access check value for any access


 The FILE_READ_ACCESS and FILE_WRITE_ACCESS constants are also defined in
 ntioapi.h as FILE_READ_DATA and FILE_WRITE_DATA. The values for these
 constants *MUST* always be in sync.
*/


#define FILE_ANY_ACCESS                 0
#define FILE_READ_ACCESS          ( 0x0001 )    /* file & pipe */
#define FILE_WRITE_ACCESS         ( 0x0002 )    /* file & pipe */

/*
  These are the generic rights.
*/

#define GENERIC_READ                     (0x80000000L)
#define GENERIC_WRITE                    (0x40000000L)
#define GENERIC_EXECUTE                  (0x20000000L)
#define GENERIC_ALL                      (0x10000000L)

#define CREATE_NEW          1
#define CREATE_ALWAYS       2
#define OPEN_EXISTING       3
#define OPEN_ALWAYS         4
#define TRUNCATE_EXISTING   5

#define FILE_SHARE_READ                 0x00000001  
#define FILE_SHARE_WRITE                0x00000002  
#define FILE_ATTRIBUTE_READONLY         0x00000001  
#define FILE_ATTRIBUTE_HIDDEN           0x00000002  
#define FILE_ATTRIBUTE_SYSTEM           0x00000004  
#define FILE_ATTRIBUTE_DIRECTORY        0x00000010  
#define FILE_ATTRIBUTE_ARCHIVE          0x00000020  
#define FILE_ATTRIBUTE_NORMAL           0x00000080  

#define	GetLastError()	(NTstatus.Status)

/*BOOL DeviceIoControl( 

    HANDLE  hDevice,    * handle of the device *
   DWORD  dwIoControlCode,     * control code of operation to perform *
    LPVOID  lpvInBuffer,        * address of buffer for input data *
    DWORD  cbInBuffer,  * size of input buffer *
    LPVOID  lpvOutBuffer,       * address of output buffer *
    DWORD  cbOutBuffer, * size of output buffer *
    LPDWORD  lpcbBytesReturned, * address of actual bytes of output *
    LPOVERLAPPED  lpoOverlapped         * address of overlapped structure *
  );*/

typedef struct _SECURITY_ATTRIBUTES {
    DWORD nLength;
    LPVOID lpSecurityDescriptor;
    BOOL bInheritHandle;
} SECURITY_ATTRIBUTES, *PSECURITY_ATTRIBUTES, *LPSECURITY_ATTRIBUTES;

#define ERROR_SUCCESS                    0L
#define NO_ERROR 0L
#define ERROR_GEN_FAILURE                    31
#define ERROR_BUSY                       170L
#define ERROR_INVALID_HANDLE                    6L
#define ERROR_INSUFFICIENT_BUFFER                    122L
#define ERROR_INVALID_FUNCTION                    1L
#define ERROR_NOT_ENOUGH_MEMORY                    8L
#define ERROR_NO_DATA_DETECTED                    1104L
#define ERROR_IO_DEVICE                    1117L
#define ERROR_FILE_NOT_FOUND             2L
#define ERROR_INVALID_PARAMETER                    87L
#define ERROR_READ_FAULT                    30L
#define ERROR_WRITE_FAULT                   29
#define ERROR_ACCESS_DENIED                    5L
#define ERROR_ALLOTTED_SPACE_EXCEEDED                    1344L
#define ERROR_TOO_MANY_OPEN_FILES                    4L
#define ERROR_OPERATION_ABORTED                    995L
#define ERROR_IO_PENDING                    997L
#define ERROR_MORE_DATA                    234L

#include "winioctl.h"
#endif
